#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_pool4xi.py">
#<abstract4xi abstract = "tests pool4xi"/>
#<verify4xi verification = "10" target = "manager4xi.py"/>
#<contextualize4xi context = "pool4xi.py"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_test_pool4xi',
            'print_trace4xi',
            'set_trace4xi',
            'phase2',
            'phase1',
            'expxi8',
            'expxi4',
            'expxi2',
            'ace',
            'reason',
            'sense']            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   


#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing.process import Process
from multiprocessing.queues  import Queue
from multiprocessing.connection import Pipe
from multiprocessing.synchronize import Lock
from multiprocessing import Manager #<--- this is because Manager function is defined in __init__.py module!
from multiprocessing.pool import Pool
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi
from pool4xi import Pool4Xi

from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(STEP 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(STEP 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(STEP 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(STEP 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(STEP 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(STEP 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(STEP 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(STEP 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(STEP 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(STEP 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(STEP 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(STEP 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(STEP 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'ApplyResult4Xi': 'NACK4TRACE',
        'Condition4Xi': 'NACK4TRACE',
        'Lock4Xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'PipeClient4Xi': 'NACK4TRACE',
        'PipeConnection4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Pool4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'ThreadPool4Xi': 'NACK4TRACE',
        'worker4xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(STEP 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(STEP 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-pool4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Pools in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Pools in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-pool4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Pools in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Pools in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-pool4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Pools in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Pools in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>


     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "expxi2" usage = "
#   two exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi2(x_param):
    xi2 = x_param
    return xi2*xi2
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# expxi4 function for pool workers
#<function4xi function = "expxi4" usage = "
#   four exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi4(x_param):
    xi4 = x_param
    return xi4*xi4*xi4*xi4
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
# expxi8 function for pool workers
#<function4xi function = "expxi8" usage = "
#   eight exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi8(x_param):
    xi8 = x_param
    return xi8*xi8*xi8*xi8*xi8*xi8*xi8*xi8         
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase1" usage = "
#   pool testing with multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def phase1():    

    # ---------------------------------------------------------------------------------------------
    # create three pools with worker processes 
    # ---------------------------------------------------------------------------------------------
    print ("\nCREATING THREE POOLS WITH WORKER PROCESSES ", time4xi())        
    pool2xi = Pool(processes=2)
    pool4xi = Pool(processes=4)
    pool8xi = Pool(processes=8)

    result2xi = pool2xi.apply_async(expxi2, (20,))
    print ("\nResult from pool2xi workers: ",result2xi.get(timeout=1))    
    # 400 
    
    result4xi = pool4xi.apply_async(expxi4, (40,))
    print ("\nResult from pool4xi workers: ",result4xi.get(timeout=1))
    # 2560000
    
    result8xi = pool8xi.apply_async(expxi8, (80,))
    print ("\nResult from pool8xi workers: ",result8xi.get(timeout=1))
    #1677721600000000
    
    print ("\nCREATED THREE POOLS WITH WORKER PROCESSES ", time4xi()) 
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase2" usage = "
#   pool testing with dragonized multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def phase2():    
    count2errors4result = 0

    # ---------------------------------------------------------------------------------------------
    # CREATE THREE POOLS WITH WORKER PROCESSES 
    # ---------------------------------------------------------------------------------------------     
    print ("\n(STEP 8A/33) CREATING THREE POOLS WITH DRAGONIXED WORKER PROCESSES ", time4xi()) 
    # 04:41:52 01/17/13 Pacific Standard Time
    
    pool2xi = Pool4Xi(processes=2)
    print ("\n(STEP 8B/33) CREATED POOL2XI WITH 2 PROCESSES ", pool2xi) 
    # <pool4xi.Pool4Xi object at 0x0000000002A327B8>
    
    pool4xi = Pool4Xi(processes=4)
    print ("\n(STEP 8C/33) CREATED POOL4XI WITH 4 PROCESSES ", pool4xi)
    # <pool4xi.Pool4Xi object at 0x00000000038F23C8>
    
    pool8xi = Pool4Xi(processes=8)
    print ("\n(STEP 8D/33) CREATED POOL8XI WITH 8 PROCESSES ", pool2xi)
    # <pool4xi.Pool4Xi object at 0x0000000002A327B8>
    
    print ("\n(STEP 8E/33) CREATING THREE POOLS WITH DRAGONIXED WORKER PROCESSES", time4xi()) 
    # 04:42:08 01/17/13 Pacific Standard Time
    
    # ---------------------------------------------------------------------------------------------
    # SENSE POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    print ("\n(STEP 9A/33) GETTING SENSE POOL RESULT FUNCTION ", time4xi())
    # 04:42:08 01/17/13 Pacific Standard Time
    
    result2xi = pool2xi.apply_async(expxi2, (20,))
    print ("\n(STEP 9B/33) GOT RESULT2XI FUNCTION: ",result2xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003BE9630>
    
    r2xi = result2xi.get(timeout=1)
    if r2xi is None:
        print ("\n(STEP 9Z1/33) *** ERROR RESULT R2XI ", r2xi)
        # *** ERROR RESULT R2XI  None 
        count2errors4result = count2errors4result + 1
    else:    
        print ("\n(STEP 9C/33) GOT RESULT R2XI: ",r2xi)  
        # 
        if r2xi == 400:
            print ("\n(STEP 9D/33) OK RESULT R2XI : ",r2xi)  
            # 
        else:
            print ("\n(STEP 9E/33) *** ERROR RESULT R2XI : ",r2xi, " EXPECTED: ", 400 )  
            # 
            count2errors4result = count2errors4result + 1    
    
    
    
    # ---------------------------------------------------------------------------------------------
    # REASON POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    print ("\n(STEP 10A/33) GETTING REASON POOL RESULT FUNCTION ", time4xi())
    # 04:42:08 01/17/13 Pacific Standard Time
    
    result4xi = pool4xi.apply_async(expxi4, (40,))
    print ("\n(STEP 10B/33) GOT RESULT4XI FUNCTION: ", result4xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003BE9748>
    
    r4xi = result4xi.get(timeout=1)
    if r4xi is None:
        print ("\n(STEP 10Z1/33) *** ERROR RESULT R4XI ", r4xi)
        # *** ERROR RESULT R4XI  None
        count2errors4result = count2errors4result + 1 
    else:    
        print ("\n(STEP 10C/33) GOT R4XI: ",r4xi)     
        # 
        if r4xi == 400:
            print ("\n(STEP 10D/33) OK RESULT R4XI : ",r4xi)  
            # 
        else:
            print ("\n(STEP 10E/33) *** ERROR RESULT R4XI : ",r4xi, " EXPECTED: ", 2560000)  
            # 
            count2errors4result = count2errors4result + 1  
                
    # ---------------------------------------------------------------------------------------------
    # ACE POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    print ("\n(STEP 11A/33) GETTING ACE POOL RESULT FUNCTION ", time4xi())
    # 04:42:08 01/17/13 Pacific Standard Time
    
    result8xi = pool8xi.apply_async(expxi8, (80,))
    
    print ("\n(STEP 11B/33) GOT RESULT8XI FUNCTION: ",result8xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003BE97F0>
    
    r8xi = result8xi.get(timeout=1)
    if r8xi is None:
        print ("\n(STEP 11Z1/33) *** ERROR RESULT R8XI ", r4xi)
        # *** ERROR RESULT R8XI  None
        count2errors4result = count2errors4result + 1 
    else:      
        print ("\n(STEP 11C/33) GOT R8XI: ",r8xi)     
        # 
        if r8xi == 1677721600000000:
            print ("\n(STEP 11D/33) OK RESULT R8XI : ",r8xi)  
            # 
        else:
            print ("\n(STEP 11E/33) *** ERROR RESULT R8XI : ",r8xi, " EXPECTED: ", 1677721600000000)  
            # 
            count2errors4result = count2errors4result + 1
                        
    # ---------------------------------------------------------------------------------------------
    # COMPLETED 
    # ---------------------------------------------------------------------------------------------     
    if count2errors4result == 0:
        print ("\n(STEP 12A/33) SUCCEEDED WITH ", count2errors4result, " , ERRORS IN POOLTESTS WITH DRAGONIXED WORKER PROCESSES! ", time4xi())
    else:
        print ("\n(STEP 12Z/33) *** FOUND ", count2errors4result, " ERRORS IN POOLTESTS WITH DRAGONIXED WORKER PROCESSES *** ", time4xi()) 
        # *** FOUND  3  ERRORS IN POOLTESTS WITH DRAGONIXED WORKER PROCESSES ***  04:54:20 01/17/13 Pacific Standard Time 
             
#</function4xi>
     
            

  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_pool4xi" usage = "
#   testing process references
#">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_pool4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(STEP 1/5) OF TEST_POOL4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000002A8C588>
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        ack2phase1 = False                                                                                       # default, test only once due to time out error!
        if ack2phase1 is True:
            print("(STEP 2A/5) OF TEST_POOL4XI - PHASE1 STARTING ", time4xi())
            phase1()
            print("(STEP 2B/5) OF TEST_POOL4XI - PHASE1 COMPLETED ", time4xi())
        else:
            print("(STEP 2Z/5) OF TEST_POOL4XI - PHASE1 SKIPPED ", time4xi())
            # 04:41:52 01/17/13 Pacific Standard Time
            
        ack2phase2 = True                                                                                        # default
        if ack2phase2 is True:
            print("(STEP 3A/5) OF TEST_POOL4XI - PHASE2 STARTING ", time4xi())
            # 04:41:52 01/17/13 Pacific Standard Time
                                     
            phase2() 
            print("(STEP 3B/5) OF TEST_POOL4XI - PHASE2 COMPLETED ", time4xi())
        else:
            print("(STEP 3Z/5) OF TEST_POOL4XI - PHASE2 SKIPPED ", time4xi())
                       
    finally:        
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
       
        
#</function4xi>        
    
 
# -------------------------------------------------------------------------------------------------
# main                              
#<function4xi function = "main" usage = "
#   main function to test process references
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():
    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_pool4xi() 
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
    
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':

    main()
    
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#    
# None
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_pool4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
